#!/bin/bash
#
# This script will check it the external programs (mostly standard *nix tools) and SExtractor
# are present in the $PATH
#
MISSING_PROGRAM=0
LIST_OF_MISSING_PROGRAMS=""
echo " "
echo -e "Starting script \033[01;32m$0\033[00m"
# Check if C compiler name was supplied
if [ ! -z $1 ];then
 C_COMPILER=$1
else
 C_COMPILER=gcc
fi

FORTRAN_COMPILER=`lib/find_fortran_compiler.sh`

for TESTED_PROGRAM in $C_COMPILER $FORTRAN_COMPILER g++ awk sed bc cat cut sort touch head tail grep basename curl wget ;do
 echo -n "Looking for $TESTED_PROGRAM - "
 if ! which $TESTED_PROGRAM &>/dev/null ;then
  MISSING_PROGRAM=1
  LIST_OF_MISSING_PROGRAMS="$LIST_OF_MISSING_PROGRAMS  $TESTED_PROGRAM"
  echo -e "\033[01;31mNOT found\033[00m"
 else
  echo -e "\033[01;32mFound\033[00m"
 fi
done
if [ $MISSING_PROGRAM -eq 1 ] ;then
 echo -e "
ERROR: some programs needed for VaST were not found in the \$PATH!
\033[01;31mPlease install the following programs before compiling VaST:

$LIST_OF_MISSING_PROGRAMS\033[00m
"
 exit 1
else
 echo "All the external programs were found!"
fi
