#!/bin/bash
#
# This script will parse vast_image_details.log and generate a stub vast_summary.log
# It is not intended to be run by a user, the main vast program will start it automatically...
#
LAST_JD=0
FIRST_JD=9953219
IS_REF_IMAGE=1
# Fix the log (just in case it was if broken)
if [ ! -f vast_image_details.log ];then
 echo "WARNING! Something is terribly wrong: the log file vast_image_details.log is not found."
 exit
fi
lib/fix_photo_log < vast_image_details.log > tmp.log
mv -f tmp.log vast_image_details.log
#
if [ ! -f vast_image_details.log ];then
 echo "WARNING! Something is terribly wrong: the log file vast_image_details.log is not found."
 exit
fi
while read exp_start_name exp_start_date exp_start_time exp_name exp JD_name JD ap_name ap rotation_name rotation detected_name detected matched_name matched status  filename ;do
 if [ $IS_REF_IMAGE -eq 1 ];then
  IS_REF_IMAGE=0
  JD_REF=$JD
  exp_start_date_ref=$exp_start_date
  exp_start_time_ref=$exp_start_time
  filename_ref=$filename
 fi
 if [ "$JD" != "0.000000" ];then
  TEST=`echo "$JD < $FIRST_JD"|bc -ql`
  if [ $TEST -eq 1 ];then
   FIRST_JD=$JD
   exp_start_date_first=$exp_start_date
   exp_start_time_first=$exp_start_time
   filename_first=$filename
  fi
  TEST=`echo "$JD > $LAST_JD"|bc -ql`
  if [ $TEST -eq 1 ];then
   LAST_JD=$JD
   exp_start_date_last=$exp_start_date
   exp_start_time_last=$exp_start_time
   filename_last=$filename
  fi
 fi
done < vast_image_details.log
echo -n "Images processed " ; grep -c JD vast_image_details.log
echo -n "Images used for photometry " ; grep -c OK vast_image_details.log
echo  "Ref.  image: $JD_REF $exp_start_date_ref $exp_start_time_ref   $filename_ref"
echo  "First image: $FIRST_JD $exp_start_date_first $exp_start_time_first   $filename_first"
echo  "Last  image: $LAST_JD $exp_start_date_last $exp_start_time_last   $filename_last" 
