#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#include "../fitsio.h"

int main(int argc, char **argv){
 int status = 0;//, anynul=0,nullval=0; //for cfitsio routines
 fitsfile *fptr; /* pointer to the FITS file; defined in fitsio.h */
 //long  fpixel = 1, naxis = 2;
 //long naxes[2]; 
 char fitsfilename[1024];
 char outputfitsfilename[1024];

 // for header file
 int i; // stupid counter
 int No_of_wcs_keys; // number of keys in header
 int wcs_keys_left; 
 char *wcs_key[256]; // pointers for keys
 //char *wcs_key_name[256]; // pointers for key names
 //char *wcs_key_comment[256]; // pointers for key comments

 //
 fitsfile *inputfptr; /* pointer to the FITS file; defined in fitsio.h */
 fitsfile *outputfptr; /* pointer to the FITS file; defined in fitsio.h */
 
// unsigned short *image_array; // to store image data
 
 
 if( argc!=3 ){
  fprintf(stderr,"Usage: %s wcs_header.fits image.fit\n", argv[0]);
  return 1;
 }
 
 /* Extract data from WCS fits header file */
 strncpy(fitsfilename,argv[1],1024);
 fits_open_file(&fptr, fitsfilename, READONLY, &status);
 if ( 0!=status ){
  fits_report_error(stderr, status);  /* print out any error messages */
  return status;
 }
 fits_get_hdrspace(fptr,&No_of_wcs_keys,&wcs_keys_left,&status);
 for(i=1;i<No_of_wcs_keys;i++){
  wcs_key[i]=(char *)malloc(80*sizeof(char));
//  wcs_key_name[i]=(char *)malloc(80*sizeof(char));
//  wcs_key_comment[i]=(char *)malloc(80*sizeof(char));
//  fits_read_keyn(fptr,i,wcs_key_name[i],wcs_key[i],wcs_key_comment[i],&status);
  fits_read_record(fptr,i,wcs_key[i],&status);
 }
 fits_close_file(fptr, &status); // close file
 
// for(i=1;i<No_of_wcs_keys;i++){
//  fprintf(stdout,"%s %s %s\n",wcs_key_name[i],wcs_key[i],wcs_key_comment[i]);
// }
 //return 0;
 
 /* Read image */
 strncpy(fitsfilename,argv[2],1024);
 fits_open_file(&inputfptr, fitsfilename, READONLY, &status);
 sprintf(outputfitsfilename,"wcs_%s",fitsfilename);
 fprintf(stderr,"Creating new image file (%s)...  ",outputfitsfilename);
 fits_create_file(&outputfptr, outputfitsfilename, &status);   /* create new file */
 if ( 0!=status ){
  fits_report_error(stderr, status);
  fprintf(stderr,"ERROR: problem creating new file!\n");
  return status;
 }
 fprintf(stderr,"done!\n");
 fprintf(stderr,"Copying HDU...  "); 
 fits_copy_hdu(inputfptr,outputfptr,0,&status);
 if ( 0!=status ){
  fits_report_error(stderr, status);
  fprintf(stderr,"ERROR: problem copying HDU!\n");
  fits_close_file(inputfptr, &status); // close file     
  fits_close_file(outputfptr, &status); // close file
  return status;
 }
 fprintf(stderr,"done!\n");
 
 // Remove all keys which we absolutely don't want to see duplicated 
 status=0;
 fits_delete_key(outputfptr,"CTYPE1",&status);
 status=0;
 fits_delete_key(outputfptr,"CTYPE2",&status);
 status=0;
 fits_delete_key(outputfptr,"EQUINOX",&status);
 status=0;
 fits_delete_key(outputfptr,"LONPOLE",&status);
 status=0;
 fits_delete_key(outputfptr,"LATPOLE",&status);
 status=0;
 fits_delete_key(outputfptr,"CRVAL1",&status);
 status=0;
 fits_delete_key(outputfptr,"CRVAL2",&status);
 status=0;
 fits_delete_key(outputfptr,"CRPIX1",&status);
 status=0;
 fits_delete_key(outputfptr,"CRPIX2",&status);
 status=0;
 fits_delete_key(outputfptr,"CUNIT1",&status);
 status=0;
 fits_delete_key(outputfptr,"CUNIT2",&status);
 status=0;
 fits_delete_key(outputfptr,"CD1_1",&status);
 status=0;
 fits_delete_key(outputfptr,"CD1_2",&status);
 status=0;
 fits_delete_key(outputfptr,"CD2_1",&status);
 status=0;
 fits_delete_key(outputfptr,"CD2_2",&status);
 status=0;
 fits_delete_key(outputfptr,"IMAGEW",&status);
 status=0;
 fits_delete_key(outputfptr,"IMAGEH",&status);
 status=0;
 fits_delete_key(outputfptr,"A_ORDER",&status);
 status=0;
 fits_delete_key(outputfptr,"A_0_2",&status);
 status=0;
 fits_delete_key(outputfptr,"A_1_1",&status);
 status=0;
 fits_delete_key(outputfptr,"A_2_0",&status);
 status=0;
 fits_delete_key(outputfptr,"B_ORDER",&status);
 status=0;
 fits_delete_key(outputfptr,"B_0_2",&status);
 status=0;
 fits_delete_key(outputfptr,"B_1_1",&status);
 status=0;
 fits_delete_key(outputfptr,"B_2_0",&status);
 status=0;
 fits_delete_key(outputfptr,"AP_ORDER",&status);
 status=0;
 fits_delete_key(outputfptr,"AP_0_1",&status);
 status=0;
 fits_delete_key(outputfptr,"AP_0_2",&status);
 status=0;
 fits_delete_key(outputfptr,"AP_1_0",&status);
 status=0;
 fits_delete_key(outputfptr,"AP_1_1",&status);
 status=0;
 fits_delete_key(outputfptr,"AP_2_0",&status);
 status=0;
 fits_delete_key(outputfptr,"BP_ORDER",&status);
 status=0;
 fits_delete_key(outputfptr,"BP_0_1",&status);
 status=0;
 fits_delete_key(outputfptr,"BP_0_2",&status);
 status=0;
 fits_delete_key(outputfptr,"BP_1_0",&status);
 status=0;
 fits_delete_key(outputfptr,"BP_1_1",&status);
 status=0;
 fits_delete_key(outputfptr,"BP_2_0",&status);
 status=0;
 fits_delete_key(outputfptr,"CDELT1",&status);
 status=0;
 fits_delete_key(outputfptr,"CDELT2",&status);
 status=0;
 fits_delete_key(outputfptr,"CROTA1",&status);
 status=0;
 fits_delete_key(outputfptr,"CROTA2",&status);
 status=0;
 
 //fprintf(stderr,"A %d\n",status);
 
 for(i=0;i<100;i++){ 
  fits_delete_key(outputfptr,"TR?_*",&status);
  status=0;
 }
 
 //fprintf(stderr,"B %d\n",status);
 
 for(i=0;i<100;i++){
  fits_delete_key(outputfptr,"HISTORY",&status);
  status=0;
 }
 
// fits_delete_key(outputfptr,"",&status);
// fits_delete_key(outputfptr,"",&status);
// fits_delete_key(outputfptr,"",&status);
 
 status=0;

 for(i=5;i<No_of_wcs_keys;i++){
  fits_write_record(outputfptr,wcs_key[i],&status);
 }

 fits_close_file(inputfptr, &status); // close file
 fits_close_file(outputfptr, &status); // close file

 fits_report_error(stderr, status);  /* print out any error messages */
   
 
 fprintf(stderr, "All done!\n"); 
 
// free(image_array);
 
 return 0;
}
