#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <dirent.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "limits.h"
#include "photocurve.h"

int main (int argc, char **argv){
 DIR *dp;
 struct dirent *ep;

 /* Mag conversion */
 double a,b,c;
 a=b=c=0;
 FILE *lightcurvefile;
 FILE *outlightcurvefile;
 double jd,mag,merr,x,y,app,newmag;
 char string[FILENAME_LENGTH];
 
 int operation_mode=0; // 0 - polynome (or straight line) , 4 and 5 - special "photocurve" mode
 
 double a_[4]; // for parameters of "photocurve"
 
 if(argc!=4 && argc!=6){
  fprintf(stderr,"Magnitude converter\n");
  fprintf(stderr,"Usage:\n");
  fprintf(stderr,"util/calibrate_magnitude_scale A B C\n");
  fprintf(stderr," magnitude will be calibrated using relation Mout=A*Min*Min+B*Min+C\n");
  fprintf(stderr,"\n");
  fprintf(stderr,"There is also an alternative operation mode for use with lib/fit_mag_calib\n");
  exit(1);
 }

 if( argc==4 ){
  operation_mode=0; // just in case
  a=atof(argv[1]);
  b=atof(argv[2]);
  c=atof(argv[3]);
  fprintf(stderr,"a=%lf b=%lf c=%lf\n",a,b,c);
 }
 
if( argc==6 ){
 operation_mode=atoi(argv[1]);
// if( operation_mode==5 ){
//  fprintf(stderr,"Sorry, this function is not (yet) implemented. :(\nTry another one!\n(No magnitude calibration applied)\n");
//  exit(1);
// }
 a_[0]=atof(argv[2]); 
 a_[1]=atof(argv[3]);
 a_[2]=atof(argv[4]);
 a_[3]=atof(argv[5]);
}




 dp = opendir ("./");
 if (dp != NULL){
  fprintf(stderr,"Working...\nPlease, PLEASE, be patient!!!\n");
  while( ep=readdir(dp) ){
   if( strlen(ep->d_name)<12 )continue; // make sure the filename is not too short for the following tests   
   if( ep->d_name[0]=='o' && ep->d_name[1]=='u' && ep->d_name[2]=='t' && ep->d_name[strlen(ep->d_name)-1]=='t' && ep->d_name[strlen(ep->d_name)-2]=='a' && ep->d_name[strlen(ep->d_name)-3]=='d' ){
    //puts (ep->d_name);
    lightcurvefile=fopen(ep->d_name,"r");
    if( NULL==lightcurvefile ){
     fprintf(stderr,"ERROR: Can't open file %s\n",ep->d_name);
     exit(1);
    }
    outlightcurvefile=fopen("lightcurve.tmp","w");
    if( NULL==outlightcurvefile ){
     fprintf(stderr,"ERROR: Can't open file lightcurve.tmp\n");
     exit(1);
    }
    while(-1<fscanf(lightcurvefile,"%lf %lf %lf %lf %lf %lf %s",&jd,&mag,&merr,&x,&y,&app,string)){
     if( operation_mode==0 )
      newmag=a*mag*mag+b*mag+c;
     if( operation_mode==4 || operation_mode==5 )
      newmag=eval_photocurve( mag, a_, operation_mode);
     fprintf(outlightcurvefile,"%.5lf %8.5lf %.5lf %8.3lf %8.3lf %4.1lf %s\n",jd,newmag,merr,x,y,app,string);
    }
    fclose(outlightcurvefile);
    fclose(lightcurvefile);
    unlink(ep->d_name); /* delete old lightcurve file */
    rename("lightcurve.tmp",ep->d_name); /* move lightcurve.tmp to lightcurve file */
   }
  }
  (void) closedir (dp);
 }
 else
  perror("Couldn't open the directory");
  
  fprintf(stderr,"All done!  =)\n");                                         

  return 0;
}
