#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <math.h>

#include "limits.h"
                    
int main (int argc, char **argv){
 DIR *dp;
 struct dirent *ep;

 FILE *lightcurvefile;
 FILE *outlightcurvefile;
 double jd,mag,merr,x,y,app;
 char string[FILENAME_LENGTH];
 
 if( argc>=2 && 0==strcmp("-h",argv[1]) ){
  fprintf(stderr,"Clean out*dat files from \"nan\" values.\n");
  fprintf(stderr,"Usage:\n");
  fprintf(stderr,"%s\n",argv[0]);
  exit(0);
 }
 
 dp = opendir ("./");
 if (dp != NULL){
  fprintf(stderr,"Wiping out bad (nan) measurements... ");
  while( ep = readdir(dp) ){
   if( strlen(ep->d_name)<12 )continue; // make sure the filename is not too short for the following tests
   if( ep->d_name[0]=='o' && ep->d_name[1]=='u' && ep->d_name[2]=='t' && ep->d_name[strlen(ep->d_name)-1]=='t' && ep->d_name[strlen(ep->d_name)-2]=='a' && ep->d_name[strlen(ep->d_name)-3]=='d' ){
    lightcurvefile=fopen(ep->d_name,"r");
    if( NULL==lightcurvefile ){
     fprintf(stderr,"ERROR: Can't open file %s\n",ep->d_name);
     exit(1);
    }
    outlightcurvefile=fopen("lightcurve.tmp","w");
    if( NULL==outlightcurvefile ){
     fprintf(stderr,"ERROR: Can't open file lightcurve.tmp\n");
     exit(1);
    }
    while(-1<fscanf(lightcurvefile,"%lf %lf %lf %lf %lf %lf %s",&jd,&mag,&merr,&x,&y,&app,string)){
     if( 0==isnan(jd) && 0==isnan(mag) && 0==isnan(merr) && 0==isnan(x) && 0==isnan(y) && 0==isnan(app) )fprintf(outlightcurvefile,"%.5lf %8.5lf %.5lf %8.3lf %8.3lf %4.1lf %s\n",jd,mag,merr,x,y,app,string);
    }
    fclose(outlightcurvefile);
    fclose(lightcurvefile);
    unlink(ep->d_name); /* delete old lightcurve file */
    rename("lightcurve.tmp",ep->d_name); /* move lightcurve.tmp to lightcurve file */
   }
  }
  (void) closedir (dp);
 }
 else
  perror("Couldn't open the directory\n");
  
  fprintf(stderr,"done!  =)\n");                                         

  return 0;
}
