#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "limits.h"

int main(int argc, char **argv){
 FILE *infile;
 FILE *outfile;
 double JD,M,MERR,X,Y,APP;
 char str[DATA_PARSER_C_MAX_STR_LENGTH];
 char infilename[DATA_PARSER_C_MAX_STR_LENGTH];
 char outfilename[DATA_PARSER_C_MAX_STR_LENGTH];
 double faintest;
 int n_drop=0;
 if( argc<3 ){
  fprintf(stderr,"Usage: ./drop_faint_points N_POINTS outNUM.dat\n");
  fprintf(stderr,"Example: ./drop_faint_points 5 outNUM.dat - drop 5 faintest points from lightcurve\n");
  fprintf(stderr,"Output will be written to outDROP.dat\n");
  return 1;
 }
 n_drop=atoi(argv[1]);
 strcpy(infilename,argv[2]);
 strcpy(outfilename,"outDROP.dat");
 do{
  /* Find faintest point */
  faintest=-999.0;
  //fprintf(stderr,"Find faintest point %s\n",infilename);
  infile=fopen(infilename,"r");
  while(-1<fscanf(infile,"%lf %lf %lf %lf %lf %lf %s",&JD,&M,&MERR,&X,&Y,&APP,str)){
   if(M>faintest)faintest=M;
  }
  fclose(infile);
  /* Remove faintest point */
  infile=fopen(infilename,"r");
  outfile=fopen(outfilename,"w");
 //  fprintf(stderr,"Remove faintest point %s %s\n",infilename,outfilename);
  while(-1<fscanf(infile,"%lf %lf %lf %lf %lf %lf %s",&JD,&M,&MERR,&X,&Y,&APP,str)){
   if(M<faintest)fprintf(outfile, "%lf %.4lf %.4lf %.3lf %.3lf %.1lf %s\n",JD,M,MERR,X,Y,APP,str);
  }
  fclose(infile); 
  fclose(outfile);
  if(n_drop>1){
   system("mv outDROP.dat outDROP.dat.tmp");
   strcpy(infilename,"outDROP.dat.tmp");
  }
  n_drop--;
 }while(n_drop>0);
 system("rm -f outDROP.dat.tmp");
 return 0;
}
