#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <getopt.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include <sys/wait.h>
#include <sys/time.h>
#include <sys/resource.h>
              
#include "cpgplot.h"

#include "setenv_local_pgplot.h"

#include "limits.h"

float myfmin(float x, float y){
 if( x>y )
  return y;
 else
  return x; 
}

float myfmax(float x, float y){
 if( x>y )
  return x;
 else
  return y; 
}


void call_scripts(int period_search_switch){
 char cmd[512];
 //if (strlen(dir)==0)strcpy(dir,"./");
 //strcpy(cmd, dir); 
 //strcat(cmd, "util/nopgplot.sh");
 strcpy(cmd, "util/nopgplot.sh");
 if(period_search_switch==1)strcat(cmd," -t");
 system(cmd);
 return;
}


int find_closest(float *x, float *y, float *X, float *Y,int N, float new_X1, float new_X2, float new_Y1, float new_Y2){
 float y_to_x_scaling_factor=fabsf(new_X2-new_X1)/fabsf(new_Y2-new_Y1);
 int i;
 float best_dist;
 float best_x,best_y;
 best_x=X[0];best_y=Y[0];
 int best_dist_num=0;
 best_dist=((*x)-X[0])*((*x)-X[0])+((*y)-Y[0])*((*y)-Y[0])*y_to_x_scaling_factor*y_to_x_scaling_factor; //!!
 for(i=1;i<N;i++){
  if( ((*x)-X[i])*((*x)-X[i])+((*y)-Y[i])*((*y)-Y[i])*y_to_x_scaling_factor*y_to_x_scaling_factor<best_dist ){
   best_dist=((*x)-X[i])*((*x)-X[i])+((*y)-Y[i])*((*y)-Y[i])*y_to_x_scaling_factor*y_to_x_scaling_factor;
   best_x=X[i];
   best_y=Y[i];
   best_dist_num=i; 
  }
 }
 (*x)=best_x;
 (*y)=best_y;
 return best_dist_num;   
}
                  

int main(int argc, char **argv){
 char COMMAND_STR[512];
 //char dir_name[512];
 //char bin_dir_name[512];
 float *cand_mag=NULL;
 float *cand_sigma=NULL;
 int Ncanstar=0;
 FILE *datamsigma_file;
 float *mag=NULL;
 float *sigma=NULL;
 float *X=NULL;
 float *Y=NULL;
 char **outfilename=NULL;
 int Nstar=0;
 int i;//,j;
 float maxSIGMA,minSIGMA,maxM,minM;
 /* PGPLOT vars */
 float curX,curY;
 char curC;
 /* for zoom */
 float draw_X_min,draw_X_max,draw_X_min_current,draw_X_max_current;
 float draw_Y_min,draw_Y_max,draw_Y_min_current,draw_Y_max_current; 
 float curX2,curY2;
 /* ----------- */
 float *mag2=NULL;
 float *sigma2=NULL;
 float *X2=NULL;
 float *Y2=NULL;
 char **outfilename2=NULL;
 int Nstar2=0;
 /* ----------- */
 float *mag3=NULL;
 float *sigma3=NULL;
 float *X3=NULL;
 float *Y3=NULL;
 char **outfilename3=NULL;
 int Nstar3=0;
 /* ----------- */
 float *mag_viewed=NULL;
 float *sigma_viewed=NULL;
 int Nstar_viewed=0;
 
 int status=0; // for wait()

 /* header string */
 char header_str[512];

 /* Variables needed to draw the curve deviding stars with high (spspected 
    variability candidates) and low sigma. */
 float *high_sigma_curve_mag;
 float *high_sigma_curve_limit; // actual cut-off level at a given magnitude
 int sigma_curve_N_points;//=0;
 FILE *vast_sigma_selection_curve_file;
 
 /* Mark the last inspected star */
 float markX=0.0;
 float markY=0.0; 

 /* Closest star */
 int closest_star_number;
 float closest_star_x;
 float closest_star_y;


 /* Protection against strange free() crushes */
 //setenv("MALLOC_CHECK_", "0", 1);

 int use_old_files=0;
 int t_option_set=0;
 int use_ds9_instead_of_pgfv=0;
 
 /* Options for getopt() */
 int n;
 const char* const shortopt = "t9";
 const struct option longopt[] = { {"ds9", 0, NULL, '9'}, {"tsearch", 0, NULL, 't'}, {NULL, 0, NULL, 0} }; //NULL string must be in the end                                 
 int nextopt;
 while (nextopt = getopt_long(argc, argv, shortopt, longopt, NULL), nextopt != -1) {
  switch (nextopt) {
    case '9':
     use_ds9_instead_of_pgfv=1;
     break;  
    case 't':
     t_option_set=1;
    case  -1:
     fprintf(stderr, "That's all with options\n");
     break;
  }
 }

 // does it really work?
 //getcwd(bin_dir_name, 512);
 //strcat(bin_dir_name, "/");
 //strcpy(dir_name, bin_dir_name);

 /* if there are some more option - use old files */
 for (n = optind; n < argc; n++) {
   use_old_files=1;
//   struct stat buf;
//   if (stat(argv[n], &buf)==0 && S_ISDIR(buf.st_mode)) {
//	   strncpy(dir_name, argv[n], 512);
//   }
//   if (dir_name[strlen(dir_name)]!='/'){ 
//	   strcat(dir_name, "/");
//   }
   fprintf(stderr,"Using old files.\n");
//   fprintf(stderr, "Using directory: %s\n", dir_name);
 }
 
// if (dir_name!=bin_dir_name)
//	 chdir(dir_name);

 /* else - call external scripts to produce data files */
 if( t_option_set==0 && use_old_files==0 ){
  call_scripts(0); //, bin_dir_name); /* Do not use period search */
 }
 if( t_option_set==1 && use_old_files==0 ){
  call_scripts(1); //, bin_dir_name); /* Use period search */
 }
  
 /* read data.m_sigma file */ 
 datamsigma_file=fopen("data.m_sigma","r");
 if( datamsigma_file==NULL ){
  fprintf(stderr,"ERROR: Can't open file \"data.m_sigma\"!\n");
  exit(1);
 }
 do{
  sigma=realloc(sigma,(Nstar+1)*sizeof(double));
  mag=realloc(mag,(Nstar+1)*sizeof(double));
  X=realloc(X,(Nstar+1)*sizeof(double));
  Y=realloc(Y,(Nstar+1)*sizeof(double));
  outfilename=realloc(outfilename,(Nstar+1)*sizeof(char *));
  outfilename[Nstar]=malloc(OUTFILENAME_LENGTH*sizeof(char));
  if( outfilename[Nstar]==NULL ){fprintf(stderr,"ERROR: can't allocate memory for outfilename[Nstar]!\n");return 1;}
  Nstar++;
 }while( -1<fscanf(datamsigma_file,"%f %f %f %f %s",&mag[Nstar-1],&sigma[Nstar-1],&X[Nstar-1],&Y[Nstar-1],outfilename[Nstar-1]) );
 fclose(datamsigma_file);
 Nstar--;
 
 mag_viewed=malloc(Nstar*sizeof(float));
 sigma_viewed=malloc(Nstar*sizeof(float));

 /* read candidates-p.lst file */ 
 datamsigma_file=fopen("candidates-p.lst","r");
 if( datamsigma_file==NULL ){
  if( use_old_files==1 )fprintf(stderr,"WARNING! Can't open candidates-p.lst, ANOVA period test was not conducted or no candidates were found!\n");
  Nstar2=0;
 }
 else{
  do{
   sigma2=realloc(sigma2,(Nstar2+1)*sizeof(double));
   mag2=realloc(mag2,(Nstar2+1)*sizeof(double));
   X2=realloc(X2,(Nstar2+1)*sizeof(double));
   Y2=realloc(Y2,(Nstar2+1)*sizeof(double));
   outfilename2=realloc(outfilename2,(Nstar2+1)*sizeof(char *));
   outfilename2[Nstar2]=malloc(OUTFILENAME_LENGTH*sizeof(char));
   if( outfilename2[Nstar2]==NULL ){fprintf(stderr,"ERROR: can't allocate memory for outfilename2[Nstar2]!\n");return 1;} 
   Nstar2++;
  }while( -1<fscanf(datamsigma_file,"%f %f %f %f %s",&mag2[Nstar2-1],&sigma2[Nstar2-1],&X2[Nstar2-1],&Y2[Nstar2-1],outfilename2[Nstar2-1]) );
  fclose(datamsigma_file);
  Nstar2--;
 }

 /* read candidates-bls.lst file */ 
 datamsigma_file=fopen("candidates-bls.lst","r");
 if( datamsigma_file==NULL ){
  if( use_old_files==1 )fprintf(stderr,"WARNING! Can't open candidates-bls.lst, BLS period test was not conducted or no candidates were found!\n");
  Nstar3=0;
 }
 else{
  do{
   sigma3=realloc(sigma3,(Nstar3+1)*sizeof(double));
   mag3=realloc(mag3,(Nstar3+1)*sizeof(double));
   X3=realloc(X3,(Nstar3+1)*sizeof(double));
   Y3=realloc(Y3,(Nstar3+1)*sizeof(double));
   outfilename3=realloc(outfilename3,(Nstar3+1)*sizeof(char *));
   outfilename3[Nstar3]=malloc(OUTFILENAME_LENGTH*sizeof(char));
   if( outfilename3[Nstar3]==NULL ){fprintf(stderr,"ERROR: can't allocate memory for outfilename3[Nstar3]!\n");return 1;}
   Nstar3++;
  }while( -1<fscanf(datamsigma_file,"%f %f %f %f %s",&mag3[Nstar3-1],&sigma3[Nstar3-1],&X3[Nstar3-1],&Y3[Nstar3-1],outfilename3[Nstar3-1]) );
  fclose(datamsigma_file);
  Nstar3--;
 }
 
 /*  Load the curve indicating stars with high (suspected 
     variability candidates) and low sigma from vast_sigma_selection_curve.log . */
 vast_sigma_selection_curve_file=fopen("vast_sigma_selection_curve.log","r");
 if( vast_sigma_selection_curve_file!=NULL ){
  high_sigma_curve_mag=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
  high_sigma_curve_limit=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
  sigma_curve_N_points=0;
  while(-1<fscanf(vast_sigma_selection_curve_file,"%f %f",&high_sigma_curve_mag[sigma_curve_N_points],&high_sigma_curve_limit[sigma_curve_N_points])){
   sigma_curve_N_points++;
  }
  fclose(vast_sigma_selection_curve_file);
 }
 
 /* find limits */
 maxM=mag[0];
 minM=mag[0];
 maxSIGMA=sigma[0];
 minSIGMA=sigma[0];
 for(i=0;i<Nstar;i++){
  if( mag[i]>maxM )
   maxM=mag[i];
  if( mag[i]<minM )
   minM=mag[i];
  if( sigma[i]>maxSIGMA )
   maxSIGMA=sigma[i];
  if( sigma[i]<minSIGMA )
   minSIGMA=sigma[i];
 }
 /* draw picture */
 //setenv("PGPLOT_DIR","lib/pgplot/",1);
 setenv_localpgplot(argv[0]);
 fprintf(stderr,"\nStarting PGPlot ");  
 if(cpgbeg(0, "/XW", 1, 1) != 1)
  return EXIT_FAILURE;
 fprintf(stderr,"- Ok\n");
 
 fprintf(stderr,"\nClick on any star to see its lightcurve.\n");
 fprintf(stderr,"Press 'Z' and draw rectangle to zoom in.\nPress 'D', 'Z''Z' or click middle mouse button to return to the original zoom.\nPress 'X' two times or double right click to exit.\nHave fun! :)\n\n");
  
 draw_X_min=minM-(maxM-minM)/10;
 draw_X_max=maxM+(maxM-minM)/10;
 draw_X_min_current=draw_X_min;
 draw_X_max_current=draw_X_max;
 
 draw_Y_min=minSIGMA-(maxSIGMA-minSIGMA)/10;
 draw_Y_max=maxSIGMA+(maxSIGMA-minSIGMA)/10;
 draw_Y_min_current=draw_Y_min;
 draw_Y_max_current=draw_Y_max;

 do{ 
 
  cpgscr( 0, 0.10, 0.31, 0.32);  /* set default vast window background */
  cpgeras();
  cpgsvp(0.08, 0.95, 0.1, 0.92);
  cpgswin(draw_X_min_current, draw_X_max_current, draw_Y_min_current, draw_Y_max_current);
  cpgsci(0);
  cpgscr( 0, 0.08, 0.08, 0.09);  /* set background */
  if( draw_X_min_current!=draw_X_max_current && draw_Y_min_current!=draw_Y_max_current )
   cpgrect(draw_X_min_current, draw_X_max_current, draw_Y_min_current, draw_Y_max_current); /* draw background for plot */
  else
   cpgrect(draw_X_min, draw_X_max, draw_Y_min, draw_Y_max); /* draw background for plot */
  cpgsci(1);
  cpgbox("BCNST1", 0.0 , 0, "BCNST1", 0.0, 0);

  cpgsch(0.85); /* make this labels with smaller characters */ 
  cpgmtxt( "B", 2.5, 0.0, 0.0, "(bright stars)");
  cpgmtxt( "B", 2.5, 1.0, 1.0, "(faint stars)");
   
 
  cpgscf(1);
  cpgsch(1.1); /* make labels with larger characters */
  cpgscr( 1, 0.62, 0.81, 0.38); /* set color of lables */
  sprintf(header_str,"Stars measured: %d", Nstar);
  cpglab("Instrumental magnitude", "Standard deviation of instrumental magnitude", header_str);
  cpgscr( 1, 1.0, 1.0, 1.0);
  cpgsch(1.0);
  //cpgsci(2); red
  cpgsci(1);
  //cpgpt(Nstar, mag, sigma, 3); 
  cpgpt(Nstar, mag, sigma, 18); 
  //cpgscr( 1, 1.0, 1.0, 1.0); // set color index 1 to white
  
  // Mark previously viewed stars
  //cpgsci(9); // GreenYellow
  //cpgsci(11); // BlueCyan
  //cpgsci(12); // BlueMagenta
  //cpgsci(13); // RedMagenta
  cpgsci(3); // Green
  cpgpt(Nstar_viewed, mag_viewed, sigma_viewed, 18);
  
  cpgsci(3);
  cpgpt(Ncanstar, cand_mag, cand_sigma, 2);
  cpgsci(4);
  cpgpt(Nstar2, mag2, sigma2, 4);
  cpgsci(5);
  cpgpt(Nstar3, mag3, sigma3, 6);

  /* Draw the curve dividing stars with high (spspected 
     variability candidates) and low sigma. */
  if( sigma_curve_N_points!=0 ){
   cpgsci(6);
   cpgsls(4); // dotted line
   cpgline(sigma_curve_N_points,high_sigma_curve_mag,high_sigma_curve_limit);
   cpgsci(5); // set color index back to draw thouse nice blue rectangles %)
   cpgsls(1); // full line
  }
  
  /* Mark the previous viewed star */
  if( markX!=0.0 && markY!=0.0 ){
   cpgsci(2);
   cpgpt1( markX, markY, 4);
   cpgsci(5);
  }

  cpgcurs(&curX, &curY, &curC);
  if( curC=='X' || curC=='x' ){
   fprintf(stderr,"\nAre you sure you want to exit?\nIf yes, please click the right mouse button again (or press 'X')!\nOtherwise, press any key.\n");
   cpgcurs(&curX, &curY, &curC);
   if( curC=='X' || curC=='x' )
    break;
   //else
   // curC=' ';
  }
  if( curC=='A' || curC=='a' ){
   // find closest star to the cursor position
   closest_star_x=curX;
   closest_star_y=curY;
   closest_star_number=find_closest(&closest_star_x,&closest_star_y,mag,sigma,Nstar,draw_X_min_current,draw_X_max_current,draw_Y_min_current,draw_Y_max_current);
   // remember click position
   markX=closest_star_x;markY=closest_star_y;
   if( Nstar_viewed>=Nstar )Nstar_viewed=0; // make sure we don't have too much stars in the viewed stars list
   mag_viewed[Nstar_viewed]=markX;
   sigma_viewed[Nstar_viewed]=markY;
   Nstar_viewed++;
   //
   //sprintf(COMMAND_STR,"util/stat_outfile %s\n",outfilename[closest_star_number]);
   //fprintf(stderr,"%s",COMMAND_STR);
   //system(COMMAND_STR);
   if( use_ds9_instead_of_pgfv==1 )
    sprintf(COMMAND_STR,"./lc --ds9 %s\n", outfilename[closest_star_number]);
   else
    sprintf(COMMAND_STR,"./lc %s\n", outfilename[closest_star_number]);
   fprintf(stderr,"%s",COMMAND_STR);
   // fork before system() so the parent process is not blocked      
   if( 0==fork() ){system(COMMAND_STR);exit(0);}else{wait3(&status, WNOHANG, NULL);}
   //system(COMMAND_STR);
  }
  if( curC=='z' || curC=='Z' ){
   cpgband( 2, 0, curX, curY, &curX2, &curY2, &curC);
   draw_X_min_current=myfmin(curX,curX2);
   draw_X_max_current=myfmax(curX,curX2);
   draw_Y_min_current=myfmin(curY,curY2);
   draw_Y_max_current=myfmax(curY,curY2);
   
   if( curC=='Z' || curC=='z' )
    curC='D';
   else
    curC='R';
  }  
  if( curC=='D' || curC=='d' ){
   draw_X_min_current=draw_X_min;
   draw_X_max_current=draw_X_max;
   draw_Y_min_current=draw_Y_min;
   draw_Y_max_current=draw_Y_max;
  }

 }while( curC!='X' );

 for(i=0;i<Nstar;i++)
  free(outfilename[i]);
 free(outfilename); 
 free(high_sigma_curve_mag);
 free(high_sigma_curve_limit);
 free(sigma);
 free(mag);
 free(X);
 free(Y);
 
 free(mag_viewed);
 free(sigma_viewed);
 
 //unsetenv("MALLOC_CHECK_");
 return 0;
}
