#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include <gsl/gsl_sort.h>
#include <gsl/gsl_statistics.h>

#include "limits.h"

int main(){
 DIR *dp;
 struct dirent *ep;

 FILE *data_m_sigma;
 double mmag, mmerr, mx,my;
 char outfilename[FILENAME_LENGTH];

 double mmean;
 double mmedian;
 //double msigma;
 double mmax;
 double mmin; 
 
 int mnumber_of_stars=0;

  
 FILE *lightcurvefile;
 //double jd,mag,merr,x,y,app;
 //char string[FILENAME_LENGTH];
      
 double *a;
 a=malloc(MAX_NUMBER_OF_STARS*sizeof(double));
 double mean;
 double median;
 //double sigma;
 double max;
 double min; 

 int number_of_stars=0;

 char str[2048];

 dp = opendir ("./");
 if(dp != NULL){
  fprintf(stderr,"Computing lightcurve statistics... \n");
  while( ep = readdir(dp) ){
   if( strlen(ep->d_name)<12 )continue; // make sure the filename is not too short for the following tests
   if( ep->d_name[0]=='o' && ep->d_name[1]=='u' && ep->d_name[2]=='t' && ep->d_name[strlen(ep->d_name)-1]=='t' && ep->d_name[strlen(ep->d_name)-2]=='a' && ep->d_name[strlen(ep->d_name)-3]=='d' ){
    lightcurvefile=fopen(ep->d_name,"r");
    if( NULL==lightcurvefile ){
     fprintf(stderr,"ERROR: Can't open file %s\n",ep->d_name);
     exit(1);
    }
    /* Compute median mag & sigma */
    a[number_of_stars]=0.0;
    while(NULL!=fgets(str,2048,lightcurvefile))
     a[number_of_stars]+=1.0;
    fclose(lightcurvefile);
    number_of_stars++;
   }
  }
  (void) closedir (dp);
 }
 else
  perror("Couldn't open the directory\n");
  
 mean=gsl_stats_mean(a,1,number_of_stars);
 gsl_sort(a,1,number_of_stars);
 median=gsl_stats_median_from_sorted_data(a,1,number_of_stars);
 gsl_stats_minmax( &min, &max, a, 1, number_of_stars);


 
 system("util/nopgplot.sh -q 2>/dev/null");
 //system("util/nopgplot.sh");
 
 mnumber_of_stars=0;
 data_m_sigma=fopen("data.m_sigma","r");
 while(-1<fscanf(data_m_sigma,"%lf %lf %lf %lf %s", &mmag, &mmerr, &mx, &my, outfilename)){
  lightcurvefile=fopen(outfilename,"r");
  if( NULL==lightcurvefile ){
   fprintf(stderr,"ERROR: Can't open file %s\n",outfilename);
   exit(1);
  }
  /* Compute median mag & sigma */
  a[mnumber_of_stars]=0.0;
  while(NULL!=fgets(str,2048,lightcurvefile))
   a[mnumber_of_stars]+=1.0;
  fclose(lightcurvefile);  
  mnumber_of_stars++;
 }
 fclose(data_m_sigma);

 mmean=gsl_stats_mean(a,1,mnumber_of_stars);
 gsl_sort(a,1,mnumber_of_stars);
 mmedian=gsl_stats_median_from_sorted_data(a,1,mnumber_of_stars);
 gsl_stats_minmax( &mmin, &mmax, a, 1, mnumber_of_stars);
 
 
 fprintf(stdout,"Total objects detected:  %d\n",number_of_stars);
 fprintf(stdout,"Objects passed selection criteria:  %d\n",mnumber_of_stars);
 fprintf(stdout,"Measurements per detected object (mean, median, min, max): %6.1lf %6.1lf %4.0lf %4.0lf\n",mean,median,min,max);
 fprintf(stdout,"Measurements per selected object (mean, median, min, max): %6.1lf %6.1lf %4.0lf %4.0lf\n",mmean,mmedian,mmin,mmax);

 
 return 0;
}
