#include <stdio.h>
#include <stdlib.h>
#include <gsl/gsl_statistics_double.h>
#include <gsl/gsl_errno.h>

#include "limits.h"
#include "vast_math.h"

int main(int argc, char **argv){
 FILE *dmsf;
 FILE *f;
 double m,sigma,X,Y,sum,mmax,mean;
 double *data;
 double *x;
 double *y;
 double *y_limit;

 char inputfilename[FILENAME_LENGTH];
 
 /* Check if sysrem_input_star_list.lst was already created. If not - use data.m_sigma instead */
 strcpy(inputfilename,"sysrem_input_star_list.lst"); 
 dmsf=fopen(inputfilename,"r");
 if( dmsf==NULL )
  strcpy(inputfilename,"data.m_sigma");
 else
  fclose(dmsf);
  
 /* Check if data.m_sigma is there? If not - try to cteate it using util/nopgplot.sh */
 dmsf=fopen(inputfilename,"r");
 if( dmsf==NULL )
  system("util/nopgplot.sh");
 else
  fclose(dmsf);

 y_limit=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 x=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 y=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 data=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 char str[256];
 sum=-1;
 int n=0;
 int i=0;
 dmsf=fopen(inputfilename,"r");
 if( dmsf==NULL ){
  fprintf(stderr,"ERROR: Can't open file %s !\n",inputfilename);
  exit(1);
 }
 while(-1<fscanf(dmsf,"%lf %lf %lf %lf %s",&m,&sigma,&X,&Y,str)){
  if( sum==-1 ){
   sum=m;
   n=0;
   mmax=m;
  }
  if(m<=mmax+M_SIGMA_BIN_SIZE_M){
   data[n]=sigma;
   n++;
  }
  else{
   x[i]=mmax+M_SIGMA_BIN_SIZE_M/2;
   sort_data_double(data, 0, n);
   if( n>3*M_SIGMA_BIN_DROP )
    n-=M_SIGMA_BIN_DROP;
   if( n==0 && i!=0 ){
    y[i]=y[i-1];
    y_limit[i]=y_limit[i-1]; 
   }
   else{
    mean=gsl_stats_mean(data,1,n );
    y[i]=mean;
    y_limit[i]=gsl_stats_sd_m(data,1,n,mean);
   }
   if( 0!=isnan(y_limit[i]) ){
     //y_limit[i]=0;
     y_limit[i]=2*y[i];
   }
//   fprintf(stderr,"%lf %lf %lf\n",x[i], y[i], y_limit[i]);
   i++;
   n=0;
   mmax=m;
  }
 }
 fclose(dmsf);
 dmsf=fopen(inputfilename,"r");
 f=fopen("sysrem_input_star_list.tmp","w");
 while(-1<fscanf(dmsf,"%lf %lf %lf %lf %s",&m,&sigma,&X,&Y,str)){
  //if( m>sum+M_SIGMA_BIN_MAG_OTSTUP ){
   for(n=0;n<i;n++){
    if( fabs(m-x[n])<=M_SIGMA_BIN_SIZE_M/2+M_SIGMA_BIN_SIZE_M/10 ){
     if( sigma<y[n]+10*M_SIGMA_BIN_MAG_SIGMA_DETECT*y_limit[n] ){
      fprintf(f,"%10.6lf %.6lf %9.3lf %9.3lf %s\n",m,sigma,X,Y,str);
      //fprintf(f,"%lf %lf %lf %lf %s\n",m,sigma,X,Y,str);
      break; 
     }
     else{
//      fprintf(stderr,"%lf %lf %lf %lf %s    %lf %lf %lf\n",m,sigma,X,Y,str,y[n]+10*M_SIGMA_BIN_MAG_SIGMA_DETECT*y_limit[n],y[n],y_limit[n]);
      fprintf(stderr,"Excluding star %s\n",str);
     }
    }
   }
  //}
 }
 fclose(dmsf);
 fclose(f);
 system("mv sysrem_input_star_list.tmp sysrem_input_star_list.lst");
 return 0;
}
