#!/bin/bash
# This small script will copy all content of the directory REGION_NAME (previously created bu util/save.sh script)
# to the current directory. Useful to load previously saved work to the vast working directory.

if [ ! -z $1 ];then
 REGION_NAME="$1"
else
 echo "Name of a region to load?"
 read REGION_NAME
fi

# Test if the data directory exist at all
if [ ! -d $REGION_NAME ];then
 echo "Error: cannot find directory $REGION_NAME"
 exit 1
fi   

# Remove old data from the current directory in order not to mix up two different data sets
util/clean_data.sh all 

echo "Loading data from $REGION_NAME ... "
# Copy data
for i in "$REGION_NAME"/* ;do
 if [ "$i" == "$REGION_NAME/default.sex.PHOTO" ];then
  cp -i $i .
 fi
 if [ "$i" == "$REGION_NAME/default.sex" ];then
  cp -i $i .
 else
  cp -r $i .
 fi
done && echo Done
